#include <err.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

int
main(int argc, char **argv)
{
	size_t	 cc;
	size_t	 rc;
	size_t	 wc;
	char	 buf[8192];
	char	*tag;
	char	*f;
	FILE	*fp;
	int	 i;

	tag = f = NULL;
	while ((i = getopt(argc, argv, "f:t:")) != -1) {
		switch(i) {
		case 'f':
			f = optarg;
			break;
		case 't':
			tag = optarg;
			break;
		}
	}
	if (f == NULL) {
		fp = stdin;
	} else if ((fp = fopen(f, "r")) == NULL) {
		err(EXIT_FAILURE, "can't open '%s'", f);
	}
	printf("#include <inttypes.h>\n\nuint8_t %s[] = {\n", tag);
	for (rc = 1, cc = 0 ; rc != 0 ; cc += rc) {
		if ((rc = fread(buf, 1, sizeof(buf), fp)) == 0) {
			break;
		}
		for (wc = 0 ; wc < rc ; wc++) {
			if (wc > 0 && wc % 16 == 0) {
				printf("\n");
			}
			printf("%d,", buf[wc]);
		}
	}
	printf("\n};\n\n");
	fclose(fp);
	exit(0);
}
