#include "tinypy.h"

static tp_obj
class_A_init(tp_vm *tp)
{
	tp_obj	self = TP_TYPE(TP_DICT);
	tp_obj	v = TP_OBJ();

	tp_set(tp, self, tp_string("value"), v);
	return tp_None;
}

static tp_obj
class_A_test(tp_vm *tp)
{
	tp_obj	self = TP_TYPE(TP_DICT);
	tp_obj	v = tp_get(tp, self, tp_string("value"));

	tp_params_v(tp, 1, v);
	tp_print(tp);
	return tp_None;
}

int
main(int argc, char **argv)
{
	tp_obj	 instance;
	tp_obj	 tmp;
	tp_vm	*tp;

	tp = tp_init(argc, argv, 1);
	instance = tp_class(tp);
	/* create our class */
	tp_set(tp, instance, tp_string("__init__"), tp_fnc(tp, class_A_init));
	tp_set(tp, instance, tp_string("test"), tp_fnc(tp, class_A_test));
	/* instantiate it and call test */
	tmp = tp_call(tp, instance, tp_params_v(tp, 1, tp_string("OK")));
	tp_call(tp, tp_get(tp, tmp, tp_string("test")), tp_params_v(tp, 0));
	tp_deinit(tp);
	return(0);
}
